/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_BIT_SET_TREE_CREATOR_UTILS__
#define __DD_BIT_SET_TREE_CREATOR_UTILS__

#include "DDTreeCreatorUtils.h"
#include "DDBitSelector.h"

namespace double_description {

    class BitSetTreeCreatorUtils : virtual public TreeCreatorUtils {
        
        private:
        const unsigned int mTotalPlanes;
        const unsigned int mMaxPopCntRange;

        public:
        BitSetTreeCreatorUtils( const unsigned int maxElementsPerLeaf,
                                const BitList & cutMap,
                                const unsigned int planes,
                                const unsigned int maxPopCntRange ) :
            TreeCreatorUtils( maxElementsPerLeaf, cutMap ),
            mTotalPlanes( planes ),
            mMaxPopCntRange( maxPopCntRange ) {}  

        unsigned int getTotalPlanes () const {
            return mTotalPlanes;
        }

        unsigned int max_pop_cnt_range() const {
            return mMaxPopCntRange;
        }
    };
}

#endif // __DD_BIT_SET_TREE_CREATOR_UTILS__
