/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "DDCalcModule.h"

using namespace double_description;

void CalcModule::calcExendedGCD ( const mpz_class& a, const mpz_class& b ) {

	if ( b == 0 ) {

		register_t = 0;
		if ( a > 0 ) {
			register_s = 1;
			register_y = a;
		} else {
			register_s = -1;
			register_y = -a;			
		}

	} else if ( a == 0 ) {

		register_s = 0;
		if ( b > 0 ) {
			register_t = 1;
			register_y = b;
		} else {
			register_t = -1;
			register_y = -b;
		}

	} else {

		if ( abs( a ) >= abs( b ) ) {
			register_x = abs( a );
			register_y = abs( b );
		} else {
			register_x = abs( b );
			register_y = abs( a );
		}

		register_s = 0;
		register_s1 = 1;
		register_s2 = 0;

		register_t = 1;
		register_t1 = 0;
		register_t2 = 1;

		while ( register_x % register_y != 0 ) {
			register_g = register_x/register_y;
			register_r = register_x % register_y;

			register_s = register_s1 - register_g*register_s2;
			register_s1 = register_s2;
			register_s2 = register_s;

			register_t = register_t1 - register_g*register_t2;
			register_t1 = register_t2;
			register_t2 = register_t;

			register_x = register_y;
			register_y = register_r; 
		}

		if ( abs( a ) < abs( b ) ) {
			register_s1 = register_s;
			register_s = register_t;
			register_t = register_s1;
		}

		if ( a < 0 ) {
			register_s = -register_s;
		}

		if ( b < 0 ) {
			register_t = -register_t;
		}
	}
} 

