/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_EXT_POP_TREE_VERIFICATION_CONDITION__
#define __DD_EXT_POP_TREE_VERIFICATION_CONDITION__

#include "DDBitList.h"
#include "DDPopTreeVerificationCondition.h"
#include "DDExtVerificationCondition.h"

namespace double_description {

	class ExtPopTreeVerificationCondition : public ExtVerificationCondition, public PopTreeVerificationCondition {

		public:
		ExtPopTreeVerificationCondition ( const BitList & faceActiveSet,
                                          const BitList & illegal_1,
                                          const BitList & illegal_2,
                                          const BitList & regPattern,
                                          const BitList & invPattern ) :
            MapCondition( faceActiveSet ),
			VerificationCondition( faceActiveSet ),
			ExtVerificationCondition( faceActiveSet, illegal_1, illegal_2 ),
			PopTreeVerificationCondition( faceActiveSet, regPattern, invPattern ) {}

		bool holdsOnRay ( const BitList & activeSet ) const {
			return ExtVerificationCondition::holdsOnRay( activeSet );
		}

		bool holdsOnFace ( const BitList & activeSetUnion ) const {
			return ExtVerificationCondition::holdsOnFace( activeSetUnion );
		}
		
		bool holdsOnFace ( const BitList & activeSetUnion, const BitList & regPattern, const BitList & invPattern ) const {
			return PopTreeVerificationCondition::holdsOnFace( activeSetUnion, regPattern, invPattern );
		}
	};
}

#endif // __DD_EXT_POP_TREE_VERIFICATION_CONDITION__
