/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_MAP_CONDITION__
#define __DD_MAP_CONDITION__

#include "DDBitList.h"

namespace double_description {

	class MapCondition {
	
		protected:
   #ifndef __USE_TEMPLATES__
		const
   #endif
        BitList mMap;

		public:
        MapCondition () {}

		MapCondition ( const BitList & map ) :
			mMap( map ) {}

		virtual ~MapCondition() {}

		virtual bool holdsOnRay( const BitList & activeSet ) const = 0;
		
		virtual bool holdsOnFace( const BitList & activeSetUnion ) const = 0;

		virtual bool holdsOnFace( const BitList & activeSetUnion, const BitList &, const BitList & ) const = 0;	

        const BitList & getMap () const {
            return mMap;
        }
	};
}

#endif // __DD_MAP_CONDITION__
