/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_NARROW_QUERY_BITS_NEUTRALIZATION_STRATEGY__
#define __DD_NARROW_QUERY_BITS_NEUTRALIZATION_STRATEGY__

#include <vector>

#include "DDDifferentialBitStrategy.h"

namespace double_description {

    class NarrowQueryBitsNeutralizationStrategy : public DifferentialBitStrategy {

        protected:

        double getProbabilityCoeff ( const unsigned long,
                                     const double pos_probability,
                                     const double neg_probability ) const {

            return neg_probability - pos_probability;
        }
        
        public:
        NarrowQueryBitsNeutralizationStrategy ( const RayReferenceContainer & pos_entries,
                                                const RayReferenceContainer & neg_entries,
                                                const unsigned int plane ) :
            DifferentialBitStrategy( pos_entries, neg_entries, plane ) {} 
    };
}

#endif // __DD_NARROW_QUERY_BITS_NEUTRALIZATION_STRATEGY__
