/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_RAY_REF_CONTAINER_TO_ARRAY_TRANSFORMER__
#define __DD_RAY_REF_CONTAINER_TO_ARRAY_TRANSFORMER__

#include <vector>

#include "DDBitList.h"
#include "DDRayRefVisitor.h"

#include "DDRayReferenceContainer.h"

namespace double_description {

    class RayRefContainerToArrayTransformer : public RayRefVisitor {

        private:
        RayReference * mData;
        unsigned long mPosition;

        protected:
        bool hasFinished () const {
            return true;
        }

        public:
        RayRefContainerToArrayTransformer( const unsigned int capacity ) :
            RayRefVisitor() {

            mData = new RayReference[ capacity ];
        }

        virtual ~RayRefContainerToArrayTransformer () {}

        void onStart () {
            RayRefVisitor::onStart();

            mPosition = 0;
        }

        void onVisit ( const struct RayReference & ref ) {

            mData[ mPosition++ ] = ref;
        }

        const RayReference * data () const {
            return mData;
        }
    };
}

#endif // __DD_RAY_REF_CONTAINER_TO_ARRAY_TRANSFORMER__
