/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "DDRepresentationVector.h"
#include "DDUtilsFactory.h"
#include <sstream>

using namespace double_description;

const std::string RepresentationVector::toString () const {
	std::stringstream output;

	for ( unsigned long i = 0; i < getDimension(); i++ ) {
		output << ( isNonZeroAt( i ) ? getValue( i ) : 0 );
		if ( i != getDimension() - 1 ) {			
			output << " ";
		}
	}

	return output.str();
}


