/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_STATIC_VANTAGE_POINT_VISITOR__
#define __DD_STATIC_VANTAGE_POINT_VISITOR__

#include "DDVantagePointVisitor.h"

namespace double_description {

    class StaticVantagePointVisitor : virtual public VantagePointVisitor {

        protected:
        void onInit ( const RayReference & ) {
            /* There is no init phase for static vantage point visitors. */       
        }

        public:
        StaticVantagePointVisitor ( const unsigned short depth,
                                    const unsigned short capacity,
                                    const unsigned short split,
                                    const BitList & point ) :
            VantagePointVisitor( depth, capacity, split ),
            VantagePointVisitor::mVantagePoint( point ) {}
    };
}

#endif // __DD_STATIC_VANTAGE_POINT_VISITOR__
