/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_VER_QUERY_BITS_NEUTRALIZATION_STRATEGY__
#define __DD_VER_QUERY_BITS_NEUTRALIZATION_STRATEGY__

#include <vector>

#include "DDDifferentialBitStrategy.h"

namespace double_description {

    class VerQueryBitsNeutralizationStrategy : public DifferentialBitStrategy {

   /*     private:
        const unsigned long mZeroEntries;
        const std::vector<unsigned long> mZeroPopulationStats; */

        protected:

        double getProbabilityCoeff ( const unsigned long index,
                                     const double pos_probability,
                                     const double neg_probability ) const {

      //      const double zero_probability = (double)mZeroPopulationStats[index]/mZeroEntries;

            const double prob = std::min( pos_probability, neg_probability ); 

            return prob > 0.6 ? 0.0 : prob; // - zero_probability;
        }
        
        public:
        VerQueryBitsNeutralizationStrategy ( const RayReferenceContainer & zero_entries,
                                             const RayReferenceContainer & pos_entries,
                                             const RayReferenceContainer & neg_entries,
                                             const unsigned int plane ) :
            DifferentialBitStrategy( pos_entries, neg_entries, plane )/*,
            mZeroEntries( zero_entries.size() ),
            mZeroPopulationStats( createPopulationStats( zero_entries ))*/ {} 
    };
}

#endif // __DD_VER_QUERY_BITS_NEUTRALIZATION_STRATEGY__
